var ca_item;
var ca_exp = new Date(); 
var ca_mark_forum, ca_mark_subforum;
var ca_base_url;
var ca_startup = '';
var ca_ie6 = false;
var ca_ie8 = false;
var ca_ie = false;

if(document.all && !window.opera && !window.XMLHttpRequest)
{
    ca_ie6 = true;
}

ca_exp.setTime(ca_exp.getTime() + (90*24*60*60*1000));

ca_item = location.href.indexOf("#");
if(ca_item != -1)
{
    ca_base_url = location.href.slice(0, ca_item);
}
else
{
    ca_base_url = location.href;
}

$(document).ready(function() 
{
    if(ca_startup.length)
    {
        eval(ca_startup);
    }
    ca_popup_init();
	ca_forums_init();
    ca_links_init();
});

$(window).bind('load,resize', function()
{
    if(ca_ie8) check_posting_area();
});

// cookies
function ca_cookie_set(name, value) 
{
	var argv = ca_cookie_set.arguments;
	var argc = ca_cookie_set.arguments.length;
	var expires = (argc > 2) ? argv[2] : ca_exp;
	var path = (argc > 3) ? argv[3] : null;
	var domain = (argc > 4) ? argv[4] : null;
	var secure = (argc > 5) ? argv[5] : false;
	document.cookie = name + "=" + escape(value) +
		((expires == null) ? "" : ("; expires=" + expires.toGMTString())) +
		((path == null) ? "" : ("; path=" + path)) +
		((domain == null) ? "" : ("; domain=" + domain)) +
		((secure == true) ? "; secure" : "");
}

function ca_cookie_getval(offset) 
{
	var endstr = document.cookie.indexOf(";",offset);
	if (endstr == -1)
	{
		endstr = document.cookie.length;
	}
	return unescape(document.cookie.substring(offset, endstr));
}

function ca_cookie_get(name) 
{
	var arg = name + "=";
	var alen = arg.length;
	var clen = document.cookie.length;
	var i = 0;
	while (i < clen) 
	{
		var j = i + alen;
		if (document.cookie.substring(i, j) == arg)
			return ca_cookie_getval(j);
		i = document.cookie.indexOf(" ", i) + 1;
		if (i == 0)
			break;
	} 
	return null;
}


// initialize popups
function ca_popup_init()
{
    var id;
    // init minimize/maximize profiles
    $('div.post').each(function(i)
    {
        ca_item = $('div.post-maximize', this);
        if(ca_item.length > 0)
        {
            ca_item.html('<a href="javascript:void(0);" onclick="ca_post_maximize_all(); return false;"><span>&gt;&gt;</span></a>');
            ca_item.attr('id', 'post-max-' + i);
            $('div.profile-block', this).prepend('<div class="post-minimize" id="post-min-' + i + '"><a href="javascript:void(0);" onclick="ca_post_minimize_all(); return false;"><span>&lt;&lt;</span></a></div>');
            $('div.post-profile-block', this).attr('id', 'post-profile-' + i);
            $('div.postbody', this).attr('id', 'post-body-' + i);
            $('span.post-author-inline', this).attr('id', 'post-author-' + i);
        }
    });
    // hide profiles
    if(ca_cookie_get('hideprofiles') == 1 || (document.documentElement && document.documentElement.offsetWidth < 500))
    {
        ca_post_minimize_all();
    }
}

// select code
function ca_select_code(a)
{
	// Get ID of code block
	var e = a.parentNode.parentNode.parentNode.getElementsByTagName('CODE')[0];

	// Not IE
	if (window.getSelection)
	{
		var s = window.getSelection();
		// Safari
		if (s.setBaseAndExtent)
		{
			s.setBaseAndExtent(e, 0, e, e.innerText.length - 1);
		}
		// Firefox and Opera
		else
		{
			var r = document.createRange();
			r.selectNodeContents(e);
			s.removeAllRanges();
			s.addRange(r);
		}
	}
	// Some older browsers
	else if (document.getSelection)
	{
		var s = document.getSelection();
		var r = document.createRange();
		r.selectNodeContents(e);
		s.removeAllRanges();
		s.addRange(r);
	}
	// IE
	else if (document.selection)
	{
		var r = document.body.createTextRange();
		r.moveToElementText(e);
		r.select();
	}
}


// expand code
function ca_expand_code(a)
{
	// Get ID of code block
	var e = a.parentNode.parentNode.parentNode.getElementsByTagName('CODE')[0];
	if(e)
	{
	    if(e.style.overflow == 'visible')
	    {
	        e.style.maxHeight = '200px';
	        e.style.overflow = 'auto';
	    }
	    else
	    {
	        e.style.maxHeight = 'none';
	        e.style.overflow = 'visible';
	    }
	}
}

// expand forum
function ca_expand_forum(id, slide)
{
	// Find parent block
	$('#forabg-' + id + ' ul.forums').each(function(i)
	{
	    var old_visible = $(this).is(':visible');
	    if(ca_ie || ca_ie6)
	    {
	        $(this).css('display', (old_visible) ? 'none' : '');
	    }
	    else if(slide)
	    {
	        $(this).toggle('fast').parents('#forabg-' + id).toggleClass('forabg_close');
	    }
	    else
	    {
	        $(this).toggle().parents('#forabg-' + id).toggleClass();
	    }
        ca_cookie_set('expand' + id, (old_visible) ? 1 : 2);
	});
}

// expand forums
function ca_forums_init()
{
    var id;
    $('dl[id]').each(function()
    {
        if(this.id.slice(0, 7) == 'expand-')
        {
            $(this).append('<dd class="forum-expand"><a href="javascript:void(0);" onclick="ca_expand_forum(' + this.id.slice(7) + ', true); return false;" id="forumblock' + this.id.slice(7) + '"></a></dd>');
        }
    });
    $('div.forabg').each(function(i)
    {
        if(this.id && this.id.indexOf('forabg-') == 0)
        {
            id = this.id.replace(/forabg-/, '');
            if(ca_cookie_get('expand' + id) == 1)
            {
                ca_expand_forum(id, false);
				$(this).addClass('forabg forabg_close');
            }
            ca_code = '$(\'li.header\', this).dblclick(function() { ca_expand_forum(' + id + ', true); });';
            eval(ca_code);
        }
    });
}

// minimize/maximize post
function ca_post_minimize(id)
{
    $('#post-profile-' + id).css('display', 'none');
    $('#post-body-' + id).addClass('post-hidden');
    $('#post-max-' + id).css('display', 'block');
    $('#post-min-' + id).css('display', 'none');
}

function ca_post_maximize(id)
{
    $('#post-profile-' + id).css('display', '');
    $('#post-body-' + id).removeClass('post-hidden');
    $('#post-max-' + id).css('display', 'none');
    $('#post-min-' + id).css('display', 'block');
}

function ca_post_minimize_all()
{
    $('div.post-maximize').each(function(i)
    {
        id = this.id.replace(/post-max-/, '');
        ca_post_minimize(id);
    });
    ca_cookie_set('hideprofiles', 1);
}

function ca_post_maximize_all()
{
    $('div.post-maximize').each(function(i)
    {
        id = this.id.replace(/post-max-/, '');
        ca_post_maximize(id);
    });
    ca_cookie_set('hideprofiles', 0);
}

function ca_scroll(item, fast)
{
    if(item.href.slice(0, ca_base_url.length + 1) == (ca_base_url + '#'))
    {
        var $target = $(item.hash);
        $target = $target.length && $target || $('[name=\\' + item.hash.slice(1) +']');
        if($target.length) 
        {
            var targetOffset = $target.offset().top;
            $('html,body').animate({scrollTop: targetOffset}, (fast) ? 300 : 500);
            return false;
        }
    }
    return true;
}

function ca_links_init()
{
    // Initialize named links
    $('a[href*=\\#]').not('.tab a').click(function()
    {
        return ca_scroll(this, false);
    });
}

function ca_scroll_window()
{
    ca_item = location.href.indexOf("#");
    if(ca_item != -1)
    {
        ca_scroll(location, true);
    }
}

jQuery("document").ready(function($){
	/* Fixed nav */
	var nav = $('.navbar-top-fixed');
	
	$(window).scroll(function () {
		if ($(this).scrollTop() > 82) {
			nav.addClass("fixed-nav");
		} else {
			nav.removeClass("fixed-nav");
		}
	});
});